' This script opens WordPerfect, creates a new document,
' types some text and changes text attributes on selections.
'
' Tested with Corel WordPerfect 12 only.
'
' Based on the article "The Cutting Edge: Using OLE
' Automation to Control WordPerfect" by Gordon McComb
' http://gmccomb.com/vault/edge/ole.html
'
' Written by Rob van der Woude
' http://www.robvanderwoude.com

Option Explicit

Dim objWP

' Create a new WP OLE Automation object
Set objWP = CreateObject( "WordPerfect.PerfectScript" )

With objWP
	' Maximize the window
	.AppMaximize

	' Open a new document; otherwise the
	' currently active document is used!
	.FileNew

	' Set the new default font and size
	.Font = "Times New Roman"
	.FontSize = 200 ' 200 = 12pt

	' Type some text, and center the line
	.Center
	.Type "This is normal text, 12pt Times New Roman, centered" & vbLf & vbLf

	' Repeat, but select and format the text
	.Center
	.Type "This is Bold, Extra Large text, centered" & vbLf
	.MoveUp
	.SelectLineEnd
	.MoveLeft
	.FontExtraLargeToggle
	.BoldKey
	.SelectOff
	.MoveRight
	.Type vbLf

	' Repeat, this time without centering
	.Type "This is normal text, left aligned, 18pt Arial" & vbLf
	.MoveUp
	.SelectLineEnd
	.MoveLeft
	.FontSize = 300 ' 300 = 18pt
	.Font = "Arial"
	.SelectOff
	.MoveRight
	.Type vbLf

	' Once more
	.Type "This is 8pt Comic Sans MS, italics" & vbLf
	.MoveUp
	.SelectLineEnd
	.MoveLeft
	.Font = "Comic Sans MS"
	.FontSize = 133 ' 133 = 8pt
	.FontItalicToggle
	.SelectOff
	.MoveRight

	' And again
	.Type vbLf & "Normal text, underlined" & vbLf
	.MoveUp
	.SelectLineEnd
	.MoveLeft
	.FontUnderlineToggle
	.SelectOff
	.MoveRight
	.Type vbLf

	' Open the File Save As dialog and quit
	.FileSaveAsDlg
	.Quit
End With

' Release the object
Set objWP = Nothing

WScript.Echo "Done."
